﻿var dataAccess = {};
var dataMarkers = {};
var dataAccessText = {};

var app = {
    initialize: function () {
        dataMapOptions = JSON.parse(localStorage.getItem("MapOptions"));
        dataAccessText = JSON.parse(localStorage.getItem("AccessText"));
        dataMarkers = JSON.parse(localStorage.getItem("AccessMarkers"));

        if (dataMapOptions) {
            dataMapOptions = dataMapOptions.Text;
        } else {
            dataMapOptions = 'Decimal';
        }

        if (dataAccessText) {
            var Contentwrapper = addPageContent(dataAccessText);
            document.getElementById('AccessTextBox').value = Contentwrapper;
        }
        getLatLong();        
    }
};

function ucwords(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}

function addPageContent(DataObject) {
    var ContentWrapper = '';
    jQuery.each(DataObject, function (i, v) {
        if (v.Text) {
            ContentWrapper = ucwords(v.Text);
        }
    });

    ContentWrapper = ContentWrapper.replace('undefined', '');
    return ContentWrapper;
}

function ddToDms(lat, lng) {

    var lat = lat;
    var lng = lng;
    var latResult, lngResult, dmsResult;

    lat = parseFloat(lat);
    lng = parseFloat(lng);

    latResult = (lat >= 0) ? 'N' : 'S';

    // Call to getDms(lat) function for the coordinates of Latitude in DMS.
    // The result is stored in latResult variable.
    latResult += getDms(lat);

    lngResult = (lng >= 0) ? 'E' : 'W';

    // Call to getDms(lng) function for the coordinates of Longitude in DMS.
    // The result is stored in lngResult variable.
    lngResult += getDms(lng);

    // Joining both variables and separate them with a space.
    dmsResult = latResult + ' ' + lngResult;

    // Return the resultant string
    return dmsResult;
}

function getDms(val) {

    var valDeg, valMin, valSec, result;

    val = Math.abs(val);

    valDeg = Math.floor(val);
    result = valDeg + "º";

    valMin = Math.floor((val - valDeg) * 60);
    result += valMin + "'";

    valSec = Math.round((val - valDeg - valMin / 60) * 3600 * 1000) / 1000;
    result += valSec + '"';

    return result;
}
