﻿/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var contacts = {
    initialize: function() {
        this.bindEvents();
    },
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    onDeviceReady: function() {
        contacts.StartUpFunctions();

    }, StartUpFunctions :function() {
        navigator.contacts.find([navigator.contacts.fieldType.displayName], contacts.getContacts, contacts.errorHandler)
    }, getContacts : function(c) {
        var mobileDiv = document.getElementById('phoneList');
        for(var i= 0, len=c.length; i<len; i++) {
            if(c[i].phoneNumbers && c[i].phoneNumbers.length > 0 ) {
                var displayname = contacts.getName(c[i]);
                mobileDiv.innerHTML += '<li><div class="ContactName">' + displayname + '</div><div class="ContactNumber">' + c[i].phoneNumbers[0].value + '</div><div class="clearfix"></div> </li>';
            }
         }
    },errorHandler :function() {
        console.log('Error No Contacts/ No Access to contacts');
    },getName : function(c) {
        var name = c.displayName;

        if(!name || name ==='') {
            if(c.name.formatted)return c.name.formatted;
            if(c.name.givenName && c.name.familyName) return c.name.givenName +' '+ c.name.familyName;
            return 'Nameless';
        }
        return name;
    }
};
