﻿function Gload()
{
    geocoder = new google.maps.Geocoder();
}
function GUnload()
{
}

var geocoder;
var global_postcode;
var global_ngr;

function findLatLngFromPC(postcode, callbackFunction)
{

    if (postcode!="")
    {
        geocoder.geocode( { 'address': postcode}, function(results, status) {
            if (status == google.maps.GeocoderStatus.OK) {
                global_postcode=postcode;
                callbackFunction(results[0].geometry.location);
            } else {
                console.log("Geocode was not successful for the following reason: " + status);
                document.getElementById("message").innerHTML="<strong>Error: Postcode can't be found</strong>";
            }
        });
    }
}

function PointFound(point)
{
    if (global_postcode.substring(0,2).toUpperCase()=="BT")
    {
        findNGR(point.lat(), point.lng(),false, false);
        return false;
    }
    else
    {
        findNGR(point.lat(), point.lng(),true, false);
        return true;
    }
}

function findNGR(pointlat,pointlng,forBritain,called)
{
    LLtoNE(pointlat,pointlng,forBritain);
    if (forBritain)
    {
       var ngr = NE2NGR(east, north);
    }
    else
    {
       var ngr = NE2NGRire(east, north);
    }
    if(called !=true) {
      global_ngr = ngr;
    } else {
      return ngr;
    }

}

function LLtoNE(lat, lon,forBritain)
{
    var deg2rad = Math.PI / 180;
    var rad2deg = 180.0 / Math.PI;
    var phi = lat * deg2rad;      // convert latitude to radians
    var lam = lon * deg2rad;   // convert longitude to radians

    if (forBritain)
    {
        a = 6377563.396;       // OSGB semi-major axis
        b = 6356256.91;        // OSGB semi-minor axis
        e0 = 400000;           // OSGB easting of false origin
        n0 = -100000;          // OSGB northing of false origin
        f0 = 0.9996012717;     // OSGB scale factor on central meridian
        e2 = 0.0066705397616;  // OSGB eccentricity squared
        lam0 = -0.034906585039886591;  // OSGB false east
        phi0 = 0.85521133347722145;    // OSGB false north
    }
    else
    {
        a = 6377340.189;      // OSI semi-major
        b = 6356034.447;      // OSI semi-minor
        e0 = 200000;          // OSI easting of false origin
        n0 = 250000;          // OSI northing of false origin
        f0 = 1.000035;        // OSI scale factor on central meridian
        e2 = 0.00667054015;   // OSI eccentricity squared
        lam0 = -0.13962634015954636615389526147909;   // OSI false east
        phi0 = 0.93375114981696632365417456114141;    // OSI false north
    }
    var af0 = a * f0;
    var bf0 = b * f0;
    // easting
    var slat2 = Math.sin(phi) * Math.sin(phi);
    var nu = af0 / (Math.sqrt(1 - (e2 * (slat2))));
    var rho = (nu * (1 - e2)) / (1 - (e2 * slat2));
    var eta2 = (nu / rho) - 1;
    var p = lam - lam0;
    var IV = nu * Math.cos(phi);
    var clat3 = Math.pow(Math.cos(phi),3);
    var tlat2 = Math.tan(phi) * Math.tan(phi);
    var V = (nu / 6) * clat3 * ((nu / rho) - tlat2);
    var clat5 = Math.pow(Math.cos(phi), 5);
    var tlat4 = Math.pow(Math.tan(phi), 4);
    var VI = (nu / 120) * clat5 * ((5 - (18 * tlat2)) + tlat4 + (14 * eta2) - (58 * tlat2 * eta2));
    east = e0 + (p * IV) + (Math.pow(p, 3) * V) + (Math.pow(p, 5) * VI);
    // northing
    var n = (af0 - bf0) / (af0 + bf0);
    var M = Marc(bf0, n, phi0, phi);
    var I = M + (n0);
    var II = (nu / 2) * Math.sin(phi) * Math.cos(phi);
    var III = ((nu / 24) * Math.sin(phi) * Math.pow(Math.cos(phi), 3)) * (5 - Math.pow(Math.tan(phi), 2) + (9 * eta2));
    var IIIA = ((nu / 720) * Math.sin(phi) * clat5) * (61 - (58 * tlat2) + tlat4);
    north = I + ((p * p) * II) + (Math.pow(p, 4) * III) + (Math.pow(p, 6) * IIIA);
    east = Math.round(east);       // round to whole number
    north = Math.round(north);     // round to whole number
    nstr = String(north);      // convert to string
    estr = String(east);       // ditto
}

function Marc(bf0, n, phi0, phi)
{
    var Marc = bf0 * (((1 + n + ((5 / 4) * (n * n)) + ((5 / 4) * (n * n * n))) * (phi - phi0))
        - (((3 * n) + (3 * (n * n)) + ((21 / 8) * (n * n * n))) * (Math.sin(phi - phi0)) * (Math.cos(phi + phi0)))
        + ((((15 / 8) * (n * n)) + ((15 / 8) * (n * n * n))) * (Math.sin(2 * (phi - phi0))) * (Math.cos(2 * (phi + phi0))))
        - (((35 / 24) * (n * n * n)) * (Math.sin(3 * (phi - phi0))) * (Math.cos(3 * (phi + phi0)))));
    return(Marc);
}

function NE2NGR(east, north)
{
    var eX = east / 500000;
    var nX = north / 500000;
    var tmp = Math.floor(eX)-5.0 * Math.floor(nX)+17.0;
    nX = 5 * (nX - Math.floor(nX));
    eX = 20 - 5.0 * Math.floor(nX) + Math.floor(5.0 * (eX - Math.floor(eX)));
    if (eX > 7.5)
        eX = eX + 1;
    if (tmp > 7.5)
        tmp = tmp + 1;
    var eing = String(east);
    var ning = String(north);
    var lnth = eing.length;
    eing = eing.substring(lnth - 5, lnth);
    lnth = ning.length;
    ning = ning.substring(lnth - 5, lnth);
    ngr = String.fromCharCode(tmp + 65) + String.fromCharCode(eX + 65) + " " + eing + " " + ning;
    return ngr;
}

function NE2NGRire(east, north)
{
    var eX = east / 500000;
    var nX = north / 500000;
    var tmp = Math.floor(eX)-5.0 * Math.floor(nX)+17.0;
    nX = 5 * (nX - Math.floor(nX));
    eX = 20 - 5.0 * Math.floor(nX) + Math.floor(5.0 * (eX - Math.floor(eX)));
    if (eX > 7.5)
        eX = eX + 1;
    if (tmp > 7.5)
        tmp = tmp + 1;
    var eing = String(east);
    var ning = String(north);
    var lnth = eing.length;
    eing = eing.substring(lnth - 5, lnth);
    lnth = ning.length;
    ning = ning.substring(lnth - 5, lnth);
    //    ngr = String.fromCharCode(tmp + 65) + String.fromCharCode(eX + 65) + " " + eing + " " + ning;
    ngr = String.fromCharCode(eX + 65) + " " + eing + " " + ning;
    return ngr;
}
